org.icefaces.ace.component.dnd

## Class DroppableBase

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - org.icefaces.ace.component.dnd.DroppableBase

- All Implemented Interfaces:
    java.util.EventListener, javax.faces.component.behavior.ClientBehaviorHolder, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder, IceClientBehaviorHolder, IDroppable
  Direct Known Subclasses:
    Droppable

      public abstract class DroppableBase
      extends javax.faces.component.UIComponentBase
      implements IDroppable, IceClientBehaviorHolder

  Allows a specified component to act as an area where Draggable items can be moved onto and register the event.

  For more information, see the Droppable Wiki Documentation.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `DroppableBase.PropertyKeys`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `COMPONENT_TYPE`
    `static java.lang.String` | `RENDERER_TYPE`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DroppableBase()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addClientBehavior(java.lang.String eventName, javax.faces.component.behavior.ClientBehavior behavior)`
    `java.lang.String` | `getAccept()` Return the value of the `accept` property.
    `java.lang.String` | `getActiveStyleClass()` Return the value of the `activeStyleClass` property.
    `java.lang.String` | `getDatasource()` Return the value of the `datasource` property.
    `java.lang.String` | `getDefaultEventName()`
    `java.lang.String` | `getDefaultExecute(java.lang.String event)`
    `java.lang.String` | `getDefaultRender(java.lang.String event)`
    `javax.el.MethodExpression` | `getDropListener()` Return the value of the `dropListener` property.
    `java.util.Collection<java.lang.String>` | `getEventNames()`
    `java.lang.String` | `getFamily()`
    `java.lang.String` | `getFor()` Return the value of the `for` property.
    `java.lang.String` | `getHoverStyleClass()` Return the value of the `hoverStyleClass` property.
    `java.lang.String` | `getListenerArgument(java.lang.String event)`
    `java.lang.String` | `getScope()` Return the value of the `scope` property.
    `java.lang.String` | `getTolerance()` Return the value of the `tolerance` property.
    `java.lang.String` | `getWidgetVar()` Return the value of the `widgetVar` property.
    `boolean` | `isDisabled()` Return the value of the `disabled` property.
    `protected boolean` | `isPropertySet(java.lang.String finder)`
    `void` | `setAccept(java.lang.String accept)` Set the value of the `accept` property.
    `void` | `setActiveStyleClass(java.lang.String activeStyleClass)` Set the value of the `activeStyleClass` property.
    `void` | `setDatasource(java.lang.String datasource)` Set the value of the `datasource` property.
    `void` | `setDisabled(boolean disabled)` Set the value of the `disabled` property.
    `void` | `setDropListener(javax.el.MethodExpression dropListener)` Set the value of the `dropListener` property.
    `void` | `setFor(java.lang.String forValue)` Set the value of the `for` property.
    `void` | `setHoverStyleClass(java.lang.String hoverStyleClass)` Set the value of the `hoverStyleClass` property.
    `void` | `setScope(java.lang.String scope)` Set the value of the `scope` property.
    `void` | `setTolerance(java.lang.String tolerance)` Set the value of the `tolerance` property.
    `void` | `setValueExpression(java.lang.String name, javax.el.ValueExpression binding)`
    `void` | `setWidgetVar(java.lang.String widgetVar)` Set the value of the `widgetVar` property.

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addFacesListener, broadcast, clearInitialState, decode, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getClientId, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, invokeOnComponent, isRendered, isTransient, markInitialState, processDecodes, processRestoreState, processSaveState, processUpdates, processValidators, queueEvent, removeFacesListener, restoreAttachedState, restoreState, saveAttachedState, saveState, setId, setParent, setRendered, setRendererType, setTransient, setValueBinding, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getContainerClientId, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView, visitTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.faces.component.behavior.ClientBehaviorHolder

      `getClientBehaviors`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final java.lang.String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### RENDERER_TYPE

          public static final java.lang.String RENDERER_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DroppableBase

          public DroppableBase()

  - ### Method Detail

    - #### getFamily

          public java.lang.String getFamily()

      Specified by:
        `getFamily` in class `javax.faces.component.UIComponent`

    - #### setAccept

          public void setAccept(java.lang.String accept)

      Set the value of the `accept` property.

      Contents: JQuery selector to define the set of acceptable draggables.

      Specified by:
        `setAccept` in interface `IDroppable`

    - #### getAccept

          public java.lang.String getAccept()

      Return the value of the `accept` property.

      Contents: JQuery selector to define the set of acceptable draggables.

      Specified by:
        `getAccept` in interface `IDroppable`

    - #### setActiveStyleClass

          public void setActiveStyleClass(java.lang.String activeStyleClass)

      Set the value of the `activeStyleClass` property.

      Contents: Class to apply to the droppable component when an acceptable draggable is dropped.

      Specified by:
        `setActiveStyleClass` in interface `IDroppable`

    - #### getActiveStyleClass

          public java.lang.String getActiveStyleClass()

      Return the value of the `activeStyleClass` property.

      Contents: Class to apply to the droppable component when an acceptable draggable is dropped.

      Specified by:
        `getActiveStyleClass` in interface `IDroppable`

    - #### setDatasource

          public void setDatasource(java.lang.String datasource)

      Set the value of the `datasource` property.

      Contents: Allows you to set the ID of an ACE UIData component and that will provide a Java object as input for the drop event. That object is defined by matching the sibling index of the droppable to an object at that index in the UIData component backing.

      Specified by:
        `setDatasource` in interface `IDroppable`

    - #### getDatasource

          public java.lang.String getDatasource()

      Return the value of the `datasource` property.

      Contents: Allows you to set the ID of an ACE UIData component and that will provide a Java object as input for the drop event. That object is defined by matching the sibling index of the droppable to an object at that index in the UIData component backing.

      Specified by:
        `getDatasource` in interface `IDroppable`

    - #### setDisabled

          public void setDisabled(boolean disabled)

      Set the value of the `disabled` property.

      Contents: If enabled, no draggables will activate this droppable.

      Specified by:
        `setDisabled` in interface `IDroppable`

    - #### isDisabled

          public boolean isDisabled()

      Return the value of the `disabled` property.

      Contents: If enabled, no draggables will activate this droppable.

      Specified by:
        `isDisabled` in interface `IDroppable`

    - #### setDropListener

          public void setDropListener(javax.el.MethodExpression dropListener)

      Set the value of the `dropListener` property.

      Contents: MethodExpression reference to a method called whenever a draggable is moved into this droppable. The method receives a single argument, DragDropEvent.

      Specified by:
        `setDropListener` in interface `IDroppable`

    - #### getDropListener

          public javax.el.MethodExpression getDropListener()

      Return the value of the `dropListener` property.

      Contents: MethodExpression reference to a method called whenever a draggable is moved into this droppable. The method receives a single argument, DragDropEvent.

      Specified by:
        `getDropListener` in interface `IDroppable`

    - #### setFor

          public void setFor(java.lang.String forValue)

      Set the value of the `for` property.

      Contents: Id of the component to add the droppable behavior to.

      Specified by:
        `setFor` in interface `IDroppable`

    - #### getFor

          public java.lang.String getFor()

      Return the value of the `for` property.

      Contents: Id of the component to add the droppable behavior to.

      Specified by:
        `getFor` in interface `IDroppable`

    - #### setHoverStyleClass

          public void setHoverStyleClass(java.lang.String hoverStyleClass)

      Set the value of the `hoverStyleClass` property.

      Contents: Class to apply to the droppable component when an acceptable draggable is hovering.

      Specified by:
        `setHoverStyleClass` in interface `IDroppable`

    - #### getHoverStyleClass

          public java.lang.String getHoverStyleClass()

      Return the value of the `hoverStyleClass` property.

      Contents: Class to apply to the droppable component when an acceptable draggable is hovering.

      Specified by:
        `getHoverStyleClass` in interface `IDroppable`

    - #### setScope

          public void setScope(java.lang.String scope)

      Set the value of the `scope` property.

      Contents: This keyword allows sets of dragabbles and droppables with the same keyword to be associated with each other exclusively.

      Specified by:
        `setScope` in interface `IDroppable`

    - #### getScope

          public java.lang.String getScope()

      Return the value of the `scope` property.

      Contents: This keyword allows sets of dragabbles and droppables with the same keyword to be associated with each other exclusively.

      Specified by:
        `getScope` in interface `IDroppable`

    - #### setTolerance

          public void setTolerance(java.lang.String tolerance)

      Set the value of the `tolerance` property.

      Contents: This arbitrary keyword specifies the method of checking if a draggable is 'over' the droppable, possible values include: fit (drag must be smaller), intersect (drag must cover > 50%). pointer (cursor must be inside drop) and touch (any of the drop touches).

      Specified by:
        `setTolerance` in interface `IDroppable`

    - #### getTolerance

          public java.lang.String getTolerance()

      Return the value of the `tolerance` property.

      Contents: This arbitrary keyword specifies the method of checking if a draggable is 'over' the droppable, possible values include: fit (drag must be smaller), intersect (drag must cover > 50%). pointer (cursor must be inside drop) and touch (any of the drop touches).

      Specified by:
        `getTolerance` in interface `IDroppable`

    - #### setWidgetVar

          public void setWidgetVar(java.lang.String widgetVar)

      Set the value of the `widgetVar` property.

      Contents: The JavaScript component instance variable name.

      Specified by:
        `setWidgetVar` in interface `IDroppable`

    - #### getWidgetVar

          public java.lang.String getWidgetVar()

      Return the value of the `widgetVar` property.

      Contents: The JavaScript component instance variable name.

      Specified by:
        `getWidgetVar` in interface `IDroppable`

    - #### isPropertySet

          protected boolean isPropertySet(java.lang.String finder)

    - #### setValueExpression

          public void setValueExpression(java.lang.String name,
                                         javax.el.ValueExpression binding)

      Overrides:
        `setValueExpression` in class `javax.faces.component.UIComponent`

    - #### getEventNames

          public java.util.Collection<java.lang.String> getEventNames()

      Specified by:
        `getEventNames` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getEventNames` in class `javax.faces.component.UIComponentBase`

    - #### getDefaultEventName

          public java.lang.String getDefaultEventName()

      Specified by:
        `getDefaultEventName` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getDefaultEventName` in class `javax.faces.component.UIComponentBase`

    - #### getDefaultRender

          public java.lang.String getDefaultRender(java.lang.String event)

      Specified by:
        `getDefaultRender` in interface `IceClientBehaviorHolder`

    - #### getDefaultExecute

          public java.lang.String getDefaultExecute(java.lang.String event)

      Specified by:
        `getDefaultExecute` in interface `IceClientBehaviorHolder`

    - #### getListenerArgument

          public java.lang.String getListenerArgument(java.lang.String event)

      Specified by:
        `getListenerArgument` in interface `IceClientBehaviorHolder`

    - #### addClientBehavior

          public void addClientBehavior(java.lang.String eventName,
                                        javax.faces.component.behavior.ClientBehavior behavior)

      Specified by:
        `addClientBehavior` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `addClientBehavior` in class `javax.faces.component.UIComponentBase`

Copyright 2025 ICEsoft Technologies Canada, Corp. All Rights Reserved.